# template for PSet #3, Python Task #3
import sys
import numpy,random
import matplotlib.pyplot as p
import PS3_tests
from PS3_1 import unit_sample_response

# arguments:
#   y -- sequence of received voltage samples
#   h -- sequence returned by unit_sample_response
# return value
#   sequence of deconvolved voltage samples
def deconvolve(y,h):
    """
    Take the samples that are the output from a channel (y), and
    the channel's unit-sample response (h), deconvolve the
    samples, and return the reconstructed samples.  Be sure the
    length of the reconstructed samples is the same as the length
    of the input samples.

    Your code should handle the case where some number of
    the leading elements of h are zero.
    """
    #first chop off extra zeros
    #in lecture notes
    while h[0] == 0:
        h = h[1:]
        y = y[1:]
    print h
    print y

    print len(h)
    print len(y)
    #0 out the rest of h
    h = numpy.append(h, numpy.zeros(len(y)-len(h)))
    print len(h)
    
    w = []
    #don't need anymore
    #w.append((1/h[0])*(y[0])) #0
    #w.append((1/h[0])*(y[1] - h[1]*w[0])) #1
    #w.append((1/h[0])*(y[2] - h[1]*w[1] - h[2]*w[0])) #2
    #print w

    for i in range(0, len(y)):
        #the summation part
        summation = y[i]
        #sys.stdout.write('y['+str(i)+']')
        #print summation
        for j in range(1, i+1): #last one not followed
            #sys.stdout.write('-h['+str(j)+']w['+str(i-j)+']')
            summation = summation - h[j]*w[i-j]
            #print summation
        #sys.stdout.write('=')
        #print ((1/h[0])*(summation))
        w.append((1/h[0])*(summation))
    print w

    return w
    

if __name__ == '__main__':
    # Create two noise free channels
    mychannel1 = PS3_tests.channel(channelid='1',noise=1.0e-10)
    mychannel2 = PS3_tests.channel(channelid='2',noise=.05)

    # Compute the channel unit sample responses of the
    # noise-free channels
    h1 = unit_sample_response(mychannel1)
    h2 = unit_sample_response(mychannel2)

    # Generate a sequence of test samples
    samples = numpy.sin(2*numpy.pi*0.01*numpy.array(range(100)))
    samples[0:len(samples)/2] += 1.0
    samples[len(samples)/2:] += -1.0
    maxs = max(samples)
    mins = min(samples)
    samples -= mins  # Make samples positive
    samples *= 1.0/(maxs - mins) # Scale between zero and one

    # Test deconvolver
    PS3_tests.demo_deconvolve(samples,mychannel1,h1,deconvolve)
    PS3_tests.demo_deconvolve(samples,mychannel2,h2,deconvolve)

    # interact with plots before exiting
    p.show()
