import math,cmath,random
import matplotlib.pyplot as p
import PS7_tests

# return a sequence of spectral coeffients for a sequence of samples
# of a time-domain signal.  The first element of the returned sequence
# should correspond to k = -N/2 where N is the length of tseq.
def frequency_domain(tseq):
	print tseq
	N=len(tseq)
	#print N
	#k = math.floor(-N/2)
	k=-math.floor(N/2)
	kcount = 0
	#print k
	ak = []
	while kcount<N:
		#find ak
		#print 'this is a of '+str(k)
		akn = 0
		#sum over all the Ns
		for n in range(N):
			akn = tseq[n]*cmath.exp(complex(0,-k*(2*cmath.pi)/N*n))+akn
			#print akn 
		akn = akn/N
		#print akn
		ak.append(akn)
		k = k+1
		kcount=kcount+1
	return ak

# return a sequence of samples for a time-domain signal computed from
# the provided spectral coefficients.  The first element of the
# returned sequence should correspond to n = 0.  Again, N can be
# determined from the length of fseq.
def time_domain(fseq):
	#print '============time============='	
	#print fseq
    	N=len(fseq)
	n = 0
	x = []
	while n<N:
		#find xn
		print 'this is x['+str(n)+']'
		xn = 0
		#sum over all the ks
		r = range(-math.floor(N/2),math.floor(N/2)+1,1)
		kcount = 0
		#print r
		for k in r:
			xn = fseq[kcount]*cmath.exp(complex(0,k*(2*cmath.pi)/N*n))+xn
			#print xn
			kcount=kcount+1
		#print 'final'
		#only want real
		#print xn.real
		x.append(xn.real)
		n=n+1
	return x



if __name__ == '__main__':
    # compute spectral coefficients for a signal composed of
    # sines and cosines.
    N = 25
    avg = 0.7
    k_cosines = (1,-3,5,7)
    k_sines = (2,4,-6,8)
    def f(n):
        result = avg # set the average value
        for k in k_cosines: result += math.cos(k*2*math.pi*n/N)
        for k in k_sines: result += math.sin(k*2*math.pi*n/N)
        return result
    x = [f(z) for z in xrange(N)]

    a = frequency_domain(x)

    # plot the spectrum.  Please save this figure for uploading.
    PS7_tests.plot_spectrum(a)
    #p.show()

    # check for the expected results
    tol = 1e-10
    for i in xrange(N):
        k = i - (N/2)
        if k == 0:
            assert abs(a[i].real - avg) < tol and \
                   abs(a[i].imag) < tol, \
                   "a[%d], k=%d, is wrong (avg): %s" % (i,k,a[i])
        elif k in k_cosines or -k in k_cosines:
            expect = 0.5
            assert abs(a[i].real - expect) < tol and \
                   abs(a[i].imag) < tol, \
                   "a[%d], k=%d, is wrong (cosine): %s" % (i,k,a[k])
        elif k in k_sines or -k in k_sines:
            expect = -0.5 if k in k_sines else 0.5
            assert abs(a[i].imag - expect) < tol and \
                   abs(a[i].real) < tol, \
                   "a[%d], k=%d, is wrong (sine): %s" % (i,k,a[k])
        else:
            assert abs(a[i].real) < tol and \
                   abs(a[i].imag) < tol, \
                   "a[%d], k=%d, is wrong (zero): %s" % (i,k,a[k])

    # now check the other transformation
    xx = time_domain(a)

    # check for expected results
    for i in xrange(N):
        assert abs(x[i] - xx[i]) < tol,"xx[n] is wrong!"

    # try some short random sequences
    N = 5
    for i in xrange(5):
        x = [random.random() for j in xrange(N)]
        a = frequency_domain(x)
        xx = time_domain(a)
        for j in xrange(N):
            if abs(x[j] - xx[j]) > tol:
                print "test %d: xx[%d] is wrong!" % (i,j)
                print x
                print a
                print xx
                break
