import numpy,math
import cmath
import matplotlib.pyplot as p
import PS7_tests

# returns a sequence representing the causal unit sample response h[n]
# for an LTI system that approximates a low-pass filter with a cutoff
# frequency freq, where 0 <= freq <= pi.  The unit sample response
# has been scaled so that the step response is exactly 1 in the
# steady state.
def low_pass(freq):
	assert freq >= 0 and freq <= math.pi
 
	print 'filter for freq: '+str(freq/math.pi)

	#start at our value
	ans = one_zero(freq)
	print 'freq is: '+str(freq/math.pi)
	#print ans
	#iterate every pi/16
	while freq+(math.pi/16)<math.pi:
		freq = freq+(math.pi/16)
		print 'freq is: '+str(freq/math.pi)
		item = one_zero(freq)
		#print item

		ans = numpy.convolve(ans, item)
		#print ans

	#always convolve pi
	print '0'
	fourth = one_zero(math.pi)
	print fourth
	
	ans = numpy.convolve(ans, fourth)
	print ans

	#scale
	sum1=sum(ans)
	#print sum1
	#now divide by
	for i in range(len(ans)):
		ans[i]=ans[i]/sum1
	print ans
	print sum(ans)
	
	return ans

def one_zero(freq):

	#C= (1+cmath.exp(complex(0,-2*freq)))/cmath.exp(complex(0,-freq))
	C=-2*math.cos(freq)
	#print C
	return [1, C, 1]

if __name__ == '__main__':
    # try out 3 different filters at pi/4, pi/2 and 3pi/4
    for freq in (0.25,0.5,0.75):
        filter = low_pass(freq*math.pi)

        # make sure filter response is properly scaled
        #assert abs(sum(filter) - 1) < 1e-10, \
        #       "oops! steady-state step response is not 1"

        # plot the response so we can if low_pass worked!
        PS7_tests.plot_freq_response(filter)

    p.show()
