import numpy,math
import cmath
import matplotlib.pyplot as p
import PS7_tests

# returns a sequence representing the causal unit sample response h[n]
# for an LTI system that approximates a low-pass filter with a cutoff
# frequency freq, where 0 <= freq <= pi.  The unit sample response
# has been scaled so that the step response is exactly 1 in the
# steady state.
def low_pass(freq):
	assert freq >= 0 and freq <= math.pi
 
	print 'filter for freq: '+str(freq)

	
	if freq >= math.pi*.25:
		print 'pi/4'
		ans = one_zero(math.pi*.25)
		print ans

	if freq >= math.pi*.5:
		print 'pi/2'
		
		print 'two'
		two = one_zero(math.pi*.5)
		print two

		ans = numpy.convolve(ans, two)
		print ans
	
	if freq >= math.pi*.75:
		print '3pi/4'
		three = one_zero(math.pi*.75)
		print three

		ans = numpy.convolve(ans, three)
		print ans

	#always convolve 0
	print '0'
	fourth = one_zero(math.pi*0)
	print fourth
		
	ans = numpy.convolve(ans, fourth)
	print ans

	#scale
	sum1=sum(ans)
	print sum1
	#now divide by
	for i in range(len(ans)):
		ans[i]=ans[i]/sum1
	print ans
	print sum(ans)
	
	return ans

def one_zero(freq):

	C= (1+cmath.exp(complex(0,-2*freq)))/cmath.exp(complex(0,-freq))
	print C
	return [1, C, 1]

if __name__ == '__main__':
    # try out 3 different filters at pi/4, pi/2 and 3pi/4
    for freq in (0.25,0.5,0.75):
        filter = low_pass(freq*math.pi)

        # make sure filter response is properly scaled
        assert abs(sum(filter) - 1) < 1e-10, \
               "oops! steady-state step response is not 1"

        # plot the response so we can if low_pass worked!
        PS7_tests.plot_freq_response(filter)

    p.show()
